package me.unurled.sacredrealms.sr.components.entity;

import static me.unurled.sacredrealms.sr.utils.Component.textComp;

import java.util.UUID;
import me.unurled.sacredrealms.sr.components.attributes.Attribute;
import org.bukkit.entity.Entity;
import org.jetbrains.annotations.NotNull;

public class SREntity {
  private final UUID uuid;
  private final String typeId;
  private double health;
  private Long experience;

  public SREntity(@NotNull Entity e, double health, Long exp, String typeId) {
    uuid = e.getUniqueId();
    this.health = health;
    this.experience = exp;
    this.typeId = typeId;
  }

  public UUID getUuid() {
    return uuid;
  }

  public Long getExperience() {
    return experience;
  }

  public void setExperience(Long experience) {
    this.experience = experience;
  }

  public double getHealth() {
    return health;
  }

  public void setHealth(double health) {
    this.health = health;
  }

  public String getTypeId() {
    return typeId;
  }

  public void applyName(@NotNull SREntityType type, @NotNull Entity e) {
    e.customName(
        textComp(
            "<green>Lv."
                + type.getLevel()
                + " <gold>"
                + type.getName()
                + "<red>"
                + health
                + "/"
                + type.getAttributes().get(Attribute.HEALTH)
                + "❤"));
    e.setCustomNameVisible(true);
  }
}
