package me.unurled.sacredrealms.sr.config;

import java.io.File;
import me.unurled.sacredrealms.sr.SR;
import me.unurled.srcore.api.Manager;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

public class ConfigManager extends Manager {

  public static final String CONFIG_YML = "config.yml";
  private FileConfiguration config;

  /** Load the data */
  @Override
  public void loadData() {
    if (!SR.getPlugin().getDataFolder().exists()) {
      SR.getPlugin().getDataFolder().mkdirs();
    }
    File configFile = new File(SR.getPlugin().getDataFolder(), CONFIG_YML);
    if (!configFile.exists()) {
      SR.getPlugin().saveResource(CONFIG_YML, false);
      config = YamlConfiguration.loadConfiguration(configFile);
    }
    config = YamlConfiguration.loadConfiguration(configFile);
  }

  @Override
  public void saveData() {
    if (!new File(SR.getPlugin().getDataFolder() + CONFIG_YML).exists()) {
      SR.getPlugin().saveDefaultConfig();
    } else {
      SR.getPlugin().saveConfig();
    }
  }

  public FileConfiguration getConfig() {
    return config;
  }
}
