package me.unurled.sacredrealms.sr.utils;

import org.bukkit.Chunk;
import org.bukkit.World;
import org.jetbrains.annotations.NotNull;

public class ChunkWrapper {

  private int x;
  private int z;
  private World world;

  public ChunkWrapper(@NotNull Chunk chunk) {
    this.x = chunk.getX();
    this.z = chunk.getZ();
    this.world = chunk.getWorld();
  }

  @Override
  public int hashCode() {
    int hash = 17;
    hash = hash * 31 + x;
    hash = hash * 31 + z;
    hash = hash * 31 + world.hashCode();
    return hash;
  }

  @Override
  public boolean equals(Object obj) {
    if (obj == null) return false;
    if (!(obj instanceof ChunkWrapper)) return false;
    return ((ChunkWrapper) obj).x == this.x
        && ((ChunkWrapper) obj).z == this.z
        && ((ChunkWrapper) obj).world.equals(this.world);
  }

  @Override
  public String toString() {
    return "(" + x + ", " + z + ") [" + world + "]";
  }

  public int getX() {
    return x;
  }

  public void setX(int x) {
    this.x = x;
  }

  public int getZ() {
    return z;
  }

  public void setZ(int z) {
    this.z = z;
  }

  public World getWorld() {
    return world;
  }

  public void setWorld(World world) {
    this.world = world;
  }
}
