package me.unurled.sacredrealms.sr.utils;

import java.util.List;
import java.util.stream.Collectors;
import net.kyori.adventure.text.TextComponent;
import net.kyori.adventure.text.minimessage.MiniMessage;
import org.jetbrains.annotations.NotNull;

public class Component {

  public static final String NOT_PLAYER = "<red>You must be a player to use this command.";
  public static final String NO_PERMISSION = "<red>You do not have permission to use this command.";
  public static final String ERROR =
      "<red>An error occurred while executing this command. Please" + " contact an admin.";
  public static final String PLAYER_NOT_FOUND = "<red>Player not found.";

  private static MiniMessage miniMessage;

  private Component() {}

  public static net.kyori.adventure.text.@NotNull Component comp(String msg) {
    if (miniMessage == null) {
      miniMessage = MiniMessage.miniMessage();
    }
    return miniMessage.deserialize(msg);
  }

  public static net.kyori.adventure.text.@NotNull TextComponent textComp(String msg) {
    if (miniMessage == null) {
      miniMessage = MiniMessage.miniMessage();
    }
    return (TextComponent) miniMessage.deserialize(msg);
  }

  public static List<net.kyori.adventure.text.Component> fromStringList(
      @NotNull List<String> list) {
    return list.stream().map(Component::comp).collect(Collectors.toList());
  }
}
