package me.unurled.sacredrealms.sr.utils.gson;

import com.google.gson.Gson;
import com.google.gson.JsonDeserializationContext;
import com.google.gson.JsonDeserializer;
import com.google.gson.JsonElement;
import com.google.gson.JsonParseException;
import com.google.gson.JsonSerializationContext;
import com.google.gson.JsonSerializer;
import io.leangen.geantyref.TypeToken;
import java.lang.reflect.Type;
import java.util.Map;

public class MapSerializer
    implements JsonSerializer<Map<String, Object>>, JsonDeserializer<Map<String, Object>> {

  @Override
  public Map<String, Object> deserialize(
      JsonElement jsonElement, Type type, JsonDeserializationContext jsonDeserializationContext)
      throws JsonParseException {

    Type typ = new TypeToken<Map<String, Object>>() {}.getType();

    return new Gson().fromJson(jsonElement, typ);
  }

  @Override
  public JsonElement serialize(
      Map<String, Object> stringObjectMap,
      Type type,
      JsonSerializationContext jsonSerializationContext) {
    return new Gson().toJsonTree(stringObjectMap);
  }
}
